EDIT - bug #8111

User selection dialog for groups does not filter out existing users
02/19/2019 11:02 PM - Andreas Mdller

Status: Closed Start date:

Priority: Priority14 Due date:

Assignee: Katja Luther % Done: 50%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.6

Severity: normal Found in Version:

Description

... but shows all users by "*". Same holds for Group selection dialog for Users.

Associated revisions

Revision cbc83794 - 03/12/2019 12:02 PM - Katja Luther

fix #8111: filter existing users/groups for member/group selection

Revision 2040fc2c - 04/04/2019 10:53 AM - Katja Luther

ref #8111: fix selection of user

Revision 92749440 - 04/08/2019 11:47 AM - Katja Luther

fix #8111: fix saving problem for members in group

Revision ead46d0e4 - 04/08/2019 03:02 PM - Katja Luther

ref #8111: handle event when removing user in group

History

#1 - 03/12/2019 12:02 PM - Katja Luther

- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset taxeditor|cbc83794de4303c54b45309ff151¢c70627e82e1a.

#2 - 03/12/2019 12:03 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mdiller

please review

#3 - 04/03/2019 06:47 PM - Andreas Miuller

- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

With test/rem_conf_am | could not open the dialog at all, but got
NullPointerException
etaxonomy.taxeditor.ui.dialog.selection.UserSelectionDialog.<init> (UserSelectionDialog. java:66)

.etaxonomy.taxeditor.ui.dialog.selection.UserSelectionDialog.select (UserSelectionDialog. java:48)

etaxonomy.taxeditor.ui.dialog.selection.SelectionDialogFactory.getSelectionFromDialog(SelectionDialo
gFactory.java:178)
eu.etaxonomy.taxeditor.ui.selection.EntitySelectionElement.widgetSelected (EntitySelectionElement. java:2
.Widget.sendEvent (Widget.java:1079)

.TypedListener.handleEvent (TypedListener. java:249)

EventTable.sendEvent (EventTable. java:84)
Display.sendEvent (Display.java:4418)

Display.runDeferredEvents (Display.java:4236)
Display.readAndDispatch (Display. java:3824)
at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine$4.run (PartRenderingEngine.java:1121)
at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.e4.ui.internal.workbench.swt.PartRenderingEngine.run (PartRenderingEngine.java:1022)
at org.eclipse.ed.ui.internal.workbench.E4Workbench.createAndRunUI (E4Workbench. java:150)

at org.eclipse.ui.internal.Workbench$5.run (Workbench. java:693)

at org.eclipse.core.databinding.observable.Realm.runWithDefault (Realm. java:336)

at org.eclipse.ui.internal.Workbench.createAndRunWorkbench (Workbench. java:610)

at org.eclipse.ui.PlatformUI.createAndRunWorkbench (PlatformUI. java:148)

at eu.etaxonomy.taxeditor.Application.start (Application.java:24)

at org.eclipse.equinox.internal.app.EclipseAppHandle.run (EclipseAppHandle.java:196)

at org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.runApplication (EclipseAppLauncher. java:134

a
in the lodfile.

#4 - 04/04/2019 08:23 AM - Patrick Plitzner

The dialog is created in SelectionDialogFactory. But null is passed as an argument which leads to this exception. @Katja: Did you forget to push
something? This can never work with the current implementation.

if(clazz.equals (User.class)) {
return (T) UserSelectionDialog.select (shell, //conversation,
(User) currentSelection, null);

if (clazz.equals (Group.class)) {
return (T) GroupSelectionDialog.select (shell, //conversation,
(Group) currentSelection, null);

#5 - 04/04/2019 10:19 AM - Katja Luther

Another point, the cascading from group to member is not implemented. Adding or deleting a member is not saved when saving the group. If we
provide member selection in editor we should add saveOrUpdate to the cascading.

#6 - 04/04/2019 10:38 AM - Andreas Miiller
Katja Luther wrote:
Another point, the cascading from group to member is not implemented. Adding or deleting a member is not saved when saving the group. If we
provide member selection in editor we should add saveOrUpdate to the cascading.
Cascading has been explicitly removed for groups and members recently, also to avoid some security issues when deleting a user and having it still
as member at other place.
However, | don't understand the argument. Cascading does only save a member which is not yet persisted at all. Membership of an already persisted
user is not touched by cascading. As cascading does not exist, we do not allow creating new "Users" via selection dialog anymore. So cascading is
probably not needed.
If you think there is still an open issue please give more details what exactly you think does not work.
#7 - 04/04/2019 10:41 AM - Katja Luther
Andreas Milller wrote:
Katja Luther wrote:
Another point, the cascading from group to member is not implemented. Adding or deleting a member is not saved when saving the group.
If we provide member selection in editor we should add saveOrUpdate to the cascading.
Cascading has been explicitly removed for groups and members recently, also to avoid some security issues when deleting a user and having it
still as member at other place.
However, | don't understand the argument. Cascading does only save a member which is not yet persisted at all. Membership of an already
persisted user is not touched by cascading. As cascading does not exist, we do not allow creating new "Users" via selection dialog anymore. So
cascading is probably not needed.
If you think there is still an open issue please give more details what exactly you think does not work.

| also thought, that it should be saved, but it is not saved at all. When calling merge() on the group the changes in GrantedAuthorities and label are
saved, but not the added or deleted members. | debugged right before calling the merge().
#8 - 04/04/2019 10:55 AM - Katja Luther

the selection dialog is fixed, but the saving still does not work.
#9 - 04/04/2019 11:09 AM - Andreas Miiller
Can you write a test which shows that this problem is really due to merge?

By the way when calling merge saveOrUpdate cascading will not help anyway | guess. It should be merge. But as mentioned cascading is not wanted
here.

#10 - 04/04/2019 11:42 AM - Andreas Miiller

| tested with the latest version. Adding a group to a member seems to work correctly. Adding a user to a group is not stored. This to me looks like a
wrong handling of the add methods and/or bidirectionality within TaxEditor.

Can you post the code how members are added?
#11 - 04/04/2019 11:47 AM - Katja Luther
Andreas Miller wrote:

| tested with the latest version. Adding a group to a member seems to work correctly. Adding a user to a group is not stored. This to me looks like
a wrong handling of the add methods and/or bidirectionality within TaxEditor.

Can you post the code how members are added?
@Override
public void addElement (User element) {
getEntity () .addMember (element) ;
}
and when debugging on editor side, the member is added to the list of members

#12 - 04/08/2019 11:48 AM - Katja Luther

- Status changed from Feedback to Resolved

Applied in changeset taxeditor|92749440c55d13272b4d45fee634d44c0db26dcO.

#13 - 04/08/2019 11:49 AM - Katja Luther

- Assignee changed from Katja Luther to Patrick Plitzner

The problem is solved by mergeing the users added or deleted to a group while saving the bulk editor model.
please review if everything is correct.

#14 - 04/08/2019 02:19 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Patrick Plitzner to Katja Luther

Deleting users from group does not work (after reload it is still there)

#15 - 04/08/2019 03:03 PM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Miiller

Andreas Muller wrote:

Deleting users from group does not work (after reload it is still there)

sorry missed to push some changes. Now this should work.

#16 - 04/08/2019 04:53 PM - Andreas Miiller
- Status changed from Resolved to Closed

- Assignee changed from Andreas Miiller to Katja Luther
seems to work now
